import 'dart:ui';

import 'package:consoledoctor_barcode_scanner/src/enums/torch_state.dart';

/// This class defines the attributes for the mobile scanner view.
class BarcodeScannerViewAttributes {
  /// Construct a new [BarcodeScannerViewAttributes] instance.
  const BarcodeScannerViewAttributes({
    required this.currentTorchMode,
    this.numberOfCameras,
    required this.size,
    this.minExposure = 0,
    this.maxExposure = 0,
    this.maxZoom = 1.0
  });

  /// The current torch state of the active camera.
  final TorchState currentTorchMode;

  /// The number of available cameras.
  final int? numberOfCameras;

  /// The size of the camera output.
  final Size size;
  final double minExposure;
  final double maxExposure;
  final double maxZoom;
}
